package com.ruedaminute.mobile.extensions;

import java.util.ArrayList;

import android.content.Intent;
import android.os.Bundle;
import android.speech.RecognitionListener;
import android.speech.RecognizerIntent;
import android.speech.SpeechRecognizer;
import android.util.Log;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;

public class SpeechServiceSpeechFunction implements FREFunction {

	private static final String TAG = "MyStt3Activity";

	public SpeechServiceExtensionContext ctxt;
	public SpeechRecognizer sr;

	@Override
	public FREObject call(FREContext context, FREObject[] arg1) {

		SpeechServiceExtensionContext speechContext = (SpeechServiceExtensionContext)context;
		RecognitionListener ear = new listener();
		ctxt = speechContext;
		sr = speechContext.sr;
		speechContext.sr.setRecognitionListener(ear);
		startRecognition(speechContext.sr);
		return null;
	}



	private void startRecognition(SpeechRecognizer sr)
	{
		Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);        
		intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL,RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
		intent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE,"com.ruedaminute.voice");

		intent.putExtra(RecognizerIntent.EXTRA_MAX_RESULTS, 5); 
		
		sr.startListening(intent);
		Log.i("111111","11111111");
	}

	public class listener implements RecognitionListener          
	{

		public void onReadyForSpeech(Bundle params)
		{
			Log.d(TAG, "onReadyForSpeech");
		}
		public void onBeginningOfSpeech()
		{
			Log.d(TAG, "onBeginningOfSpeech");
		}
		public void onRmsChanged(float rmsdB)
		{
			//Log.d(TAG, "onRmsChanged");
		}
		public void onBufferReceived(byte[] buffer)
		{
			//Log.d(TAG, "onBufferReceived");
		}
		public void onEndOfSpeech()
		{
			Log.d(TAG, "onEndofSpeech");
		}
		public void onError(int error)
		{
			Log.d(TAG,  "error " +  error);
			
			if (error == 6 || error == 7){
				startRecognition(sr);
			} 
			else
			{
				String errorTxt = "Speech Recognizer error "+ error;
				ctxt.dispatchStatusEventAsync("ERROR", errorTxt);
			}
			
		}
		public void onResults(Bundle results)                   
		{
			//String str = new String();
			Log.d(TAG, "onResults " + results);
			ArrayList<String>data = results.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION);
			String result = new String();
			for (int i = 0; i < data.size(); i++)
			{
				Log.d(TAG, "result " + data.get(i));
				result += data.get(i);
				result +=",";
			}
			Log.d(TAG, "results: "+String.valueOf(data.size())); 
			//result += data.get(0);
			ctxt.dispatchStatusEventAsync("RESULTS", result);
			startRecognition(sr);
		}
		public void onPartialResults(Bundle partialResults)
		{
			Log.d(TAG, "onPartialResults");
		}
		public void onEvent(int eventType, Bundle params)
		{
			Log.d(TAG, "onEvent " + eventType);
		}
	}
}
